<script lang="ts">
  import { flashMessage, policies, successMessage, errorMessage } from '$lib/stores';
  import { get } from 'svelte/store';
  import Sidebar from '$lib/Sidebar.svelte';
  import SuccessMessage from '$lib/SuccessMessage.svelte';
  import ErrorMessage from '$lib/ErrorMessage.svelte';

  // Get and clear the flash message
  let flashMessageValue = get(flashMessage); // Note: intentionally not subscribed to the store, since we clear it immediately
  flashMessage.set('');

  // Reset success and error messages on page load
  successMessage.set('');
  errorMessage.set('');
</script>

<svelte:head>
  <title>Policies — FSC Policy Builder</title>
</svelte:head>

<div class="grid min-h-screen grid-cols-12">
  <Sidebar active="policies" />

  <div class="col-span-7 bg-slate-50 p-6 sm:col-span-8 lg:col-span-9">
    <h1 class="mb-5 text-2xl font-medium">Policies</h1>

    {#if flashMessageValue}
      <SuccessMessage bind:message={flashMessageValue} />
    {:else if $errorMessage}
      <ErrorMessage bind:message={$errorMessage} />
    {:else if $successMessage}
      <SuccessMessage bind:message={$successMessage} />
    {/if}

    <p class="mb-7">
      <a
        class="inline-flex items-center rounded-lg border border-indigo-600 bg-indigo-500 px-3 py-2 text-sm font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
        href="/policies/new"
      >
        <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
          <path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M12 5v14m-7-7h14"
          />
        </svg>
        Voeg een policy toe
      </a>
    </p>

    <div class="relative overflow-x-auto rounded-md border border-slate-200 bg-white px-5 pt-1">
      <table class="w-full text-left">
        <thead class="text-sm">
          <tr>
            <th scope="col" class="py-3 font-semibold">Naam</th>
            <th scope="col" class="py-3 font-semibold">Aantal regels</th>
          </tr>
        </thead>
        <tbody>
          {#each $policies as policy, i (i)}
            <tr class="border-t border-slate-200">
              <td class="py-4">
                <a class="text-blue-700 hover:underline" href="/policies/{policy.id}"
                  >{policy.name}</a
                >
              </td>
              <td class="py-4">
                <a class="text-blue-700 hover:underline" href="/policies/{policy.id}"
                  >{policy.rules.length}</a
                >
              </td>
            </tr>
          {:else}
            <tr class="border-t border-slate-200">
              <td class="py-4 text-center text-gray-600" colspan="2">
                Nog geen policies gevonden.
              </td>
            </tr>
          {/each}
        </tbody>
      </table>
    </div>
  </div>
</div>
